#include<mpi.h>
#include<stdio.h>

/* shifting in a ring with colored edges */
int main(int argc, char** argv)
{
  int send, receive;
  int rank, procs;
  MPI_Status status;

  MPI_Init(&argc, &argv);

  /* Get own rank and total number of processes */
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &procs);

  /* fill receive buffer */
  receive = rank;

  while(1)
  {
    send = receive;

    /* communicaton with colouring of the nodes */
    if(rank%2 == 0)
    {
      /* send first, then receive */
    }
    else
    {
      /* receive first, then send */
    }

    /* process 0 says which tokens he has processed */
    if(rank == 0)
      printf("I am %d, received token: %d\n", rank, receive);

    /* Stop if this process received it's own token */
    if(receive == rank)
      break;
  }

  MPI_Finalize();

  return 0;
}
